<?php
function seoFriendlyURL($string) {
	// strip/convert a few specific characters
	$specialchars = array(
	"À"=>"A",
	"Á"=>"A",
	"Â"=>"A",
	"Ã"=>"A",
	"Ä"=>"Ae",
	"Å"=>"A",
	"Œ"=>"Ae",
	"Æ"=>"Ae",
	"Ç"=>"C",
	"È"=>"E",
	"É"=>"E",
	"Ê"=>"E",
	"Ë"=>"E",
	"Ì"=>"I",
	"Í"=>"I",
	"Î"=>"I",
	"Ï"=>"I",
	"Ð"=>"D",
	"Ñ"=>"N",
	"Ò"=>"O",
	"Ó"=>"O",
	"Ô"=>"O",
	"Õ"=>"O",
	"Ö"=>"Oe",
	"Ø"=>"Oe",
	"Ù"=>"U",
	"Ú"=>"U",
	"Û"=>"U",
	"Ü"=>"Ue",
	"Ý"=>"Y",
	"Þ"=>"Y",
	"ß"=>"ss",
	"à"=>"a",
	"á"=>"a",
	"â"=>"a",
	"ã"=>"a",
	"ä"=>"ae",
	"å"=>"a",
	"æ"=>"ae",
	"ç"=>"c",
	"è"=>"e",
	"é"=>"e",
	"ê"=>"e",
	"ë"=>"e",
	"ì"=>"i",
	"í"=>"i",
	"î"=>"i",
	"ï"=>"i",
	"ð"=>"d",
	"ñ"=>"n",
	"ò"=>"o",
	"ó"=>"o",
	"ô"=>"o",
	"õ"=>"o",
	"ö"=>"oe",
	"ø"=>"oe",
	"ù"=>"u",
	"ú"=>"u",
	"û"=>"u",
	"ü"=>"ue",
	"ý"=>"y",
	"þ"=>"b",
	"ÿ"=>"y",
	"/"=>"-",
	","=>"-",
	","=>"-",
	";"=>"-",
	" "=>"-");
	$string = strtr($string,$specialchars);
	$string = preg_replace("/&([a-zA-Z])(uml|acute|grave|circ|tilde|ring);/","",$string);
	$string = preg_replace("/[^a-zA-Z0-9_.-]/","",$string);
	$string = str_replace(array('---','--'),'-', $string); 
	return $string; 
} 
?>